CREATE OR REPLACE PROCEDURE EXPORTA_AUTFORN_TEK
IS
   -- AUTOFORNE
   V_CDFILDEST    VARCHAR2(4);
   V_CDFILLANC    VARCHAR2(4);
   V_NRAUTOFORN   VARCHAR2(10);
   -- EMAIL
   -- EMAIL
   V_NMRAZSOCFORN VARCHAR2(100);
   V_DTAUTOFORN   DATE;
   
   -- ITEMAUTF
   V_CDPRODINTE   VARCHAR2(20);
   -- EMAIL
   V_NMPRODUTO    VARCHAR2(50);
   V_DTPROGENTAF  DATE;
   V_SGUNIDADE    VARCHAR2(10);
   V_QTPROGENTAF  FLOAT;
   
   CURSOR C_AUTOFORNE IS
      SELECT A.CDFILDEST, A.CDFILLANC, A.NRAUTOFORN, --EMAIL, EMAIL,
             F.NMRAZSOCFORN, A.DTAUTOFORN
        FROM AUTOFORNE A, FORNECEDOR F
       WHERE A.CDFORNECED = F.CDFORNECED
         AND EXISTS (SELECT 1
                       FROM ITEMAUTF I
                      WHERE I.CDFILLANC = A.CDFILLANC
                        AND I.CDFILDEST = A.CDFILDEST
                        AND I.NRAUTOFORN = A.NRAUTOFORN);
   
   CURSOR C_ITEMAUTF(C_CDFILDEST IN VARCHAR2, C_CDFILLANC IN VARCHAR2, C_NRAUTOFORN IN VARCHAR2) IS
      SELECT P.CDPRODINTE, -- EMAIL
             P.NMPRODUTO, I.DTPROGENTAF, P.SGUNIDADE, I.QTPROGENTAF
        FROM ITEMAUTF I, PRODUTO P
       WHERE I.CDPRODUTO  = P.CDPRODUTO
         AND I.CDFILDEST  = C_CDFILDEST
         AND I.CDFILLANC  = C_CDFILLANC
         AND I.NRAUTOFORN = C_NRAUTOFORN;
BEGIN
   OPEN C_AUTOFORNE;
   LOOP
      FETCH C_AUTOFORNE INTO V_CDFILDEST, V_CDFILLANC, V_NRAUTOFORN, -- EMAIL, --EMAIL,
                             V_NMRAZSOCFORN, V_DTAUTOFORN;
      EXIT WHEN C_AUTOFORNE%NOTFOUND;
      
      INSERT INTO INT_AUTOFORNE_TEK(NRAUTOFORN, DSEMAILOPERAPROV, DSEMAILOPERSOL, NMRAZSOCFORN)
      VALUES (V_NRAUTOFORN, NULL, NULL, V_NMRAZSOCFORN);
      
      OPEN C_ITEMAUTF(V_CDFILDEST, V_CDFILLANC, V_NRAUTOFORN);
      LOOP
         FETCH C_ITEMAUTF INTO V_CDPRODINTE, 
                               V_NMPRODUTO, V_DTPROGENTAF, V_SGUNIDADE, V_QTPROGENTAF;
         EXIT WHEN C_ITEMAUTF%NOTFOUND;
         
         INSERT INTO INT_ITEMAUTF_TEK(NRAUTOFORN, CDPRODEXTERNO, DSEMAILOPERSOL,
                                      NMPRODUTO, DTPROGENTAF, SGUNIDADE, QTPROGENTAF, DTAUTOFORN)
         VALUES(V_NRAUTOFORN, V_CDPRODINTE, NULL,
                V_NMPRODUTO, V_DTPROGENTAF, V_SGUNIDADE, V_QTPROGENTAF, V_DTAUTOFORN);
      END LOOP;
      CLOSE C_ITEMAUTF;
   END LOOP;
   CLOSE C_AUTOFORNE;
   
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      ROLLBACK;
      RAISE;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_AUTFORN_TEK','6.35.020'); END;
/
